//+------------------------------------------------------------------+
//|                                                 Gypsy_MACDv3.mq4 |
//|                                                            Gypsy |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Gypsy"
#property indicator_chart_window
//-------------------------------------------------------------------------------------------------
/*
 this indicator creates a graph representing the value of the MACD Indicator across all timeframes.
 the graph shows the values by changing the color of the column associated with the timeframe.
 
 this indicator also shows the values and direction of the MACD on a higher time frame to see the 
 direction of the trend and the values and direction of the MACD on a lower timeframe for optimal
 entry of the trades.
*/
//-------------------------------------------------------------------------------------------------

extern string macdSettings            = "MACD Settings";
extern int    macdFastEMA             = 12;  //-user defined
extern int    macdSlowEMA             = 26;  //-user defined
extern int    macdSignal              = 9;   //-user defined
//-------------------------------------------------------------------------------------------------
extern string TrendPeriod             = "Choose your Trend Period";
extern string trendPeriods            = "1,5,15,30,60,240,1440,43200";
extern int    macd_TrendPeriod=1440;                        //-user defined
extern string EntryPeriod             = "Choose your Entry Period";
extern string entryPeriods            = "1,5,15,30,60,240,1440,43200";
extern int    macd_EntryPeriod=15;                          //-user defined
//-------------------------------------------------------------------------------------------------
extern string textColor               ="Choose your text color";
extern color  macd_MainColor=White;                       //-user defined
extern string panelColor              ="Background Color of Graph";
extern color  macd_PanelColor=Black;                       //-user defined
extern string text                    ="Default font";
extern string macd_font="Arial";                     //-user defined
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int x,y;

int period[]               = {43200,10080,1440,240,60,30,15,5,1};                 //-timeframe array
string periodString[]      = {"MN1","W1 ","D1 ","H4","H1","M30","M15","M5","M1"}; //-timeframe string

string Trend,Entry,Current;
//------------------------------------MACD Calculations---------------------------------------------------------------

//-macd array
double mainArray           = iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0);
double signalArray         = iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0);

//-macd calculations for the trend--user defined trendperiod
double macd_TrendMainC     = iMACD(NULL,macd_TrendPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0);
double macd_TrendSignalC   = iMACD(NULL,macd_TrendPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0);
double macd_TrendMainP     = iMACD(NULL,macd_TrendPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,1);
double macd_TrendSignalP   = iMACD(NULL,macd_TrendPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,1);

//-current macd calculations
double macd_CurrentMainC   = iMACD(NULL,0,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0);
double macd_CurrentSignalC = iMACD(NULL,0,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0);
double macd_CurrentMainP   = iMACD(NULL,0,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0);
double macd_CurrentSignalP = iMACD(NULL,0,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0);

//-macd calculations for the entry--user defined entryperiod
double macd_EntryMainC     = iMACD(NULL,macd_EntryPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0);
double macd_EntrySignalC   = iMACD(NULL,macd_EntryPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0);
double macd_EntryMainP     = iMACD(NULL,macd_EntryPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,1);
double macd_EntrySignalP   = iMACD(NULL,macd_EntryPeriod,macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,1);

//----------------------------------------------------------------------------------------------------------------------
double levelminus10,levelminus9,levelminus8,levelminus7,levelminus6,levelminus5,levelminus4,levelminus3,levelminus2,levelminus1,
level0,levelplus1,levelplus2,levelplus3,levelplus4,levelplus5,levelplus6,levelplus7,levelplus8,levelplus9,levelplus10;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//-OnInit
int OnInit(){return(INIT_SUCCEEDED);}
//-deintit
int deinit(){ObjectsDeleteAll();return(0);}
//-start
int start()
  {
//-creates the text of the panel

   ObjectCreate("MACD MTF Analysis L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Analysis L","MACD MTF Analysis",15,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Analysis L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Analysis L",OBJPROP_XDISTANCE,25);
   ObjectSet("MACD MTF Analysis L",OBJPROP_YDISTANCE,360);

   ObjectCreate("MACD MTF Analysis line1",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Analysis line1","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Analysis line1",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Analysis line1",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Analysis line1",OBJPROP_YDISTANCE,355);

   ObjectCreate("MACD MTF Setting L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Setting L","MACD Current Settings...",10,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Setting L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Setting L",OBJPROP_XDISTANCE,40);
   ObjectSet("MACD MTF Setting L",OBJPROP_YDISTANCE,340);

   ObjectCreate("MACD MTF fastEMA L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF fastEMA L","fastEMA..."+macdFastEMA,8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF fastEMA L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF fastEMA L",OBJPROP_XDISTANCE,165);
   ObjectSet("MACD MTF fastEMA L",OBJPROP_YDISTANCE,325);

   ObjectCreate("MACD MTF slowEMA L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF slowEMA L","slowEMA..."+macdSlowEMA,8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF slowEMA L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF slowEMA L",OBJPROP_XDISTANCE,80);
   ObjectSet("MACD MTF slowEMA L",OBJPROP_YDISTANCE,325);

   ObjectCreate("MACD MTF signal L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF signal L","signal..."+macdSignal,8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF signal L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF signal L",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF signal L",OBJPROP_YDISTANCE,325);
//-------------------------------------------------------------------------------------------------
//  Trend Calculations
//------------------------------------------------------------------------------------------------- 
   ObjectCreate("MACD MTF Trend line1",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Trend line1","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Trend line1",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Trend line1",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Trend line1",OBJPROP_YDISTANCE,320);

   ObjectCreate("MACD MTF Trend",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Trend","Trend TimeFrame....",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Trend",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Trend",OBJPROP_XDISTANCE,125);
   ObjectSet("MACD MTF Trend",OBJPROP_YDISTANCE,305);

   ObjectCreate("MACD MTF Trend line2",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Trend line2","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Trend line2",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Trend line2",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Trend line2",OBJPROP_YDISTANCE,300);

   if(macd_TrendPeriod == 1)     {Trend = "1 Minute";}
   if(macd_TrendPeriod == 5)     {Trend = "5 Minute";}
   if(macd_TrendPeriod == 15)    {Trend = "15 Minute";}
   if(macd_TrendPeriod == 30)    {Trend = "30 Minute";}
   if(macd_TrendPeriod == 60)    {Trend = "1 Hour";}
   if(macd_TrendPeriod == 240)   {Trend = "4 Hour";}
   if(macd_TrendPeriod == 1440)  {Trend = "Daily";}
   if(macd_TrendPeriod == 10080) {Trend = "Weekly";}
   if(macd_TrendPeriod == 43200) {Trend = "Monthly";}

   ObjectCreate("MACD MTF TrendPeriod L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF TrendPeriod L",Trend,8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF TrendPeriod L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF TrendPeriod L",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF TrendPeriod L",OBJPROP_YDISTANCE,305);
//*************************************************************************************************
   ObjectCreate("MACD MTF Trend L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Trend L",CharToStr(233),20,"Wingdings",macd_MainColor);
   ObjectSet("MACD MTF Trend L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Trend L",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Trend L",OBJPROP_YDISTANCE,270);

//-trend arrow up
   if(macd_TrendMainC>macd_TrendSignalC)
      ObjectSetText("MACD MTF Trend L",CharToStr(228),20,"Wingdings",clrRed);

   if(macd_TrendMainC>macd_TrendSignalC && macd_TrendMainP<macd_TrendSignalP)
      ObjectSetText("MACD MTF Trend L",CharToStr(251),20,"Wingdings",clrRed);
//-trend arrow down
   if(macd_TrendMainC<macd_TrendSignalC)
      ObjectSetText("MACD MTF Trend L",CharToStr(230),20,"Wingdings",clrGreen);

   if(macd_TrendMainC<macd_TrendSignalC && macd_TrendMainP>macd_TrendSignalP)
      ObjectSetText("MACD MTF Trend L",CharToStr(251),20,"Wingdings",clrGreen);
//*************************************************************************************************

   ObjectCreate("MACD_TrendMain",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD_TrendMain",DoubleToString(macd_TrendMainC,Digits+1)+"  Main  ",10,macd_font,macd_MainColor);
   ObjectSet("MACD_TrendMain",OBJPROP_CORNER,3);
   ObjectSet("MACD_TrendMain",OBJPROP_XDISTANCE,50);
   ObjectSet("MACD_TrendMain",OBJPROP_YDISTANCE,285);

   ObjectCreate("MACD_TrendSignal",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD_TrendSignal",DoubleToString(macd_TrendSignalC,Digits+1)+"  Signal",10,macd_font,macd_MainColor);
   ObjectSet("MACD_TrendSignal",OBJPROP_CORNER,3);
   ObjectSet("MACD_TrendSignal",OBJPROP_XDISTANCE,50);
   ObjectSet("MACD_TrendSignal",OBJPROP_YDISTANCE,270);
//-------------------------------------------------------------------------------------------------     
//  Current Calculations
//-------------------------------------------------------------------------------------------------     
   ObjectCreate("MACD MTF Current line1",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Current line1","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Current line1",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Current line1",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Current line1",OBJPROP_YDISTANCE,265);

   ObjectCreate("MACD MTF Current",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Current","Current TimeFrame....",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Current",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Current",OBJPROP_XDISTANCE,118);
   ObjectSet("MACD MTF Current",OBJPROP_YDISTANCE,250);

   ObjectCreate("MACD MTF Current line2",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Current line2","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Current line2",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Current line2",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Current line2",OBJPROP_YDISTANCE,245);

   if(Period()== 1)    {Current = "1 Minute";}
   if(Period()== 5)    {Current = "5 Minute";}
   if(Period()== 15)   {Current = "15 Minute";}
   if(Period()== 30)   {Current = "30 Minute";}
   if(Period()== 60)   {Current = "1 Hour";}
   if(Period()== 240)  {Current = "4 Hour";}
   if(Period()== 1440) {Current = "Daily";}
   if(Period()== 10080){Current = "Weekly";}
   if(Period()== 43200){Current = "Monthly";}

   ObjectCreate("MACD MTF CurrentPeriod L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF CurrentPeriod L",Current,8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF CurrentPeriod L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF CurrentPeriod L",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF CurrentPeriod L",OBJPROP_YDISTANCE,250);
//*************************************************************************************************
   ObjectCreate("MACD MTF Current L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Current L",CharToStr(233),20,"Wingdings",macd_MainColor);
   ObjectSet("MACD MTF Current L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Current L",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Current L",OBJPROP_YDISTANCE,215);
//-current arrow up
   if(macd_CurrentMainC>macd_CurrentSignalC)
      ObjectSetText("MACD MTF Current L",CharToStr(228),20,"Wingdings",clrRed);

   if(macd_CurrentMainC>macd_CurrentSignalC && macd_CurrentMainP<macd_CurrentSignalP)
      ObjectSetText("MACD MTF Current L",CharToStr(251),20,"Wingdings",clrRed);
//-current arrow down
   if(macd_CurrentMainC<macd_CurrentSignalC)
      ObjectSetText("MACD MTF Current L",CharToStr(230),20,"Wingdings",clrGreen);

   if(macd_CurrentMainC<macd_CurrentSignalC && macd_CurrentMainP>macd_CurrentSignalP)
      ObjectSetText("MACD MTF Current L",CharToStr(251),20,"Wingdings",clrGreen);
//*************************************************************************************************

   ObjectCreate("MACD_CurrentMain",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD_CurrentMain",DoubleToString(macd_CurrentMainC,Digits+1)+"  Main  ",10,macd_font,macd_MainColor);
   ObjectSet("MACD_CurrentMain",OBJPROP_CORNER,3);
   ObjectSet("MACD_CurrentMain",OBJPROP_XDISTANCE,50);
   ObjectSet("MACD_CurrentMain",OBJPROP_YDISTANCE,230);

   ObjectCreate("MACD_CurrentSignal",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD_CurrentSignal",DoubleToString(macd_CurrentSignalC,Digits+1)+"  Signal",10,macd_font,macd_MainColor);
   ObjectSet("MACD_CurrentSignal",OBJPROP_CORNER,3);
   ObjectSet("MACD_CurrentSignal",OBJPROP_XDISTANCE,50);
   ObjectSet("MACD_CurrentSignal",OBJPROP_YDISTANCE,215);
//-------------------------------------------------------------------------------------------------
//  Entry Calculations
//-------------------------------------------------------------------------------------------------

   ObjectCreate("MACD MTF Entry line1",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Entry line1","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Entry line1",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Entry line1",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Entry line1",OBJPROP_YDISTANCE,210);

   ObjectCreate("MACD MTF Entry",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Entry","Entry Timeframe....",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Entry",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Entry",OBJPROP_XDISTANCE,125);
   ObjectSet("MACD MTF Entry",OBJPROP_YDISTANCE,195);

   ObjectCreate("MACD MTF Entry line2",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Entry line2","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Entry line2",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Entry line2",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Entry line2",OBJPROP_YDISTANCE,190);

   if(macd_EntryPeriod == 1)    {Entry = "1 Minute";}
   if(macd_EntryPeriod == 5)    {Entry = "5 Minute";}
   if(macd_EntryPeriod == 15)   {Entry = "15 Minute";}
   if(macd_EntryPeriod == 30)   {Entry = "30 Minute";}
   if(macd_EntryPeriod == 60)   {Entry = "1 Hour";}
   if(macd_EntryPeriod == 240)  {Entry = "4 Hour";}
   if(macd_EntryPeriod == 1440) {Entry = "Daily";}
   if(macd_EntryPeriod == 10080){Entry = "Weekly";}
   if(macd_EntryPeriod == 43200){Entry = "Monthly";}

   ObjectCreate("MACD MTF EntryPeriod L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF EntryPeriod L",Entry,8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF EntryPeriod L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF EntryPeriod L",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF EntryPeriod L",OBJPROP_YDISTANCE,195);
//*************************************************************************************************
   ObjectCreate("MACD MTF Entry L",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Entry L",CharToStr(233),20,"Wingdings",macd_MainColor);
   ObjectSet("MACD MTF Entry L",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Entry L",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Entry L",OBJPROP_YDISTANCE,160);
//-entry arrow up
   if(macd_EntryMainC>macd_EntrySignalC)
      ObjectSetText("MACD MTF Entry L",CharToStr(228),20,"Wingdings",clrRed);

   if(macd_EntryMainC>macd_EntrySignalC && macd_EntryMainP<macd_EntrySignalP)
      ObjectSetText("MACD MTF Entry L",CharToStr(251),20,"Wingdings",clrRed);
//-entry arrow down
   if(macd_EntryMainC<macd_EntrySignalC)
      ObjectSetText("MACD MTF Entry L",CharToStr(230),20,"Wingdings",clrGreen);

   if(macd_EntryMainC<macd_EntrySignalC && macd_EntryMainP>macd_EntrySignalP)
      ObjectSetText("MACD MTF Entry L",CharToStr(251),20,"Wingdings",clrGreen);
//*************************************************************************************************

   ObjectCreate("MACD_EntryMain",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD_EntryMain",DoubleToString(macd_EntryMainC,Digits+1)+"  Main  ",10,macd_font,macd_MainColor);
   ObjectSet("MACD_EntryMain",OBJPROP_CORNER,3);
   ObjectSet("MACD_EntryMain",OBJPROP_XDISTANCE,50);
   ObjectSet("MACD_EntryMain",OBJPROP_YDISTANCE,175);

   ObjectCreate("MACD_EntrySignal",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD_EntrySignal",DoubleToString(macd_EntrySignalC,Digits+1)+"  Signal",10,macd_font,macd_MainColor);
   ObjectSet("MACD_EntrySignal",OBJPROP_CORNER,3);
   ObjectSet("MACD_EntrySignal",OBJPROP_XDISTANCE,50);
   ObjectSet("MACD_EntrySignal",OBJPROP_YDISTANCE,160);

   ObjectCreate("MACD MTF Entry line3",OBJ_LABEL,0,0,0);
   ObjectSetText("MACD MTF Entry line3","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("MACD MTF Entry line3",OBJPROP_CORNER,3);
   ObjectSet("MACD MTF Entry line3",OBJPROP_XDISTANCE,10);
   ObjectSet("MACD MTF Entry line3",OBJPROP_YDISTANCE,155);
//+------------------------------------------------------------------+
//|                              Graph                               |                                
//+------------------------------------------------------------------+
//-calculations for the levels
//-yen pairs
   if(Digits==2 || Digits==3)
     {
      levelminus10=-0.0100;
      levelminus9=-0.0090;
      levelminus8=-0.0080;
      levelminus7=-0.0070;
      levelminus6=-0.0060;
      levelminus5=-0.0050;
      levelminus4=-0.0040;
      levelminus3=-0.0030;
      levelminus2=-0.0020;
      levelminus1=-0.0010;
      level0=0.0;
      levelplus1=0.0010;
      levelplus2=0.0020;
      levelplus3=0.0030;
      levelplus4=0.0040;
      levelplus5=0.0050;
      levelplus6=0.0060;
      levelplus7=0.0070;
      levelplus8=0.0080;
      levelplus9=0.0090;
      levelplus10=0.0100;
     }
//-usd pairs     
   if(Digits==4 || Digits==5)
     {
      levelminus10=-0.000100;
      levelminus9=-0.000090;
      levelminus8=-0.000080;
      levelminus7=-0.000070;
      levelminus6=-0.000060;
      levelminus5=-0.000050;
      levelminus4=-0.000040;
      levelminus3=-0.000030;
      levelminus2=-0.000020;
      levelminus1=-0.000010;
      level0=0.0;
      levelplus1=0.000010;
      levelplus2=0.000020;
      levelplus3=0.000030;
      levelplus4=0.000040;
      levelplus5=0.000050;
      levelplus6=0.000060;
      levelplus7=0.000070;
      levelplus8=0.000080;
      levelplus9=0.000090;
      levelplus10=0.000100;
     }
//-creates panel - 9 across and 21 down     
   for(x=0;x<9;x++)
      for(y=0;y<21;y++)
        {
         ObjectCreate("macdbox"+IntegerToString(x,0)+IntegerToString(y,0),OBJ_LABEL,0,0,0);
         ObjectSet("macdbox"+IntegerToString(x,0)+IntegerToString(y,0),OBJPROP_CORNER,3);
         ObjectSet("macdbox"+IntegerToString(x,0)+IntegerToString(y,0),OBJPROP_XDISTANCE,x*24+10);
         ObjectSet("macdbox"+IntegerToString(x,0)+IntegerToString(y,0),OBJPROP_YDISTANCE,y*4+25);
         ObjectSetText("macdbox"+IntegerToString(x,0)+IntegerToString(y,0),"_",30,macd_font,macd_PanelColor);
        }
//-creates period string on panel        
   for(x=0;x<9;x++)
     {
      ObjectCreate("macdperiod"+IntegerToString(x,0),OBJ_LABEL,0,0,0);
      ObjectSet("macdperiod"+IntegerToString(x,0),OBJPROP_CORNER,3);
      ObjectSet("macdperiod"+IntegerToString(x,0),OBJPROP_XDISTANCE,x*25+6);
      ObjectSet("macdperiod"+IntegerToString(x,0),OBJPROP_YDISTANCE,10);
      ObjectSetText("macdperiod"+IntegerToString(x,0),periodString[x],8,macd_font,macd_MainColor);
      //--creates directional arrows on panel
      ObjectCreate("macdarrow"+IntegerToString(x,0),OBJ_LABEL,0,0,0);
      ObjectSet("macdarrow"+IntegerToString(x,0),OBJPROP_CORNER,3);
      ObjectSet("macdarrow"+IntegerToString(x,0),OBJPROP_XDISTANCE,x*25+10);
      ObjectSet("macdarrow"+IntegerToString(x,0),OBJPROP_YDISTANCE,113);
      ObjectSetText("macdarrow"+IntegerToString(x,0),CharToStr(233),10,"Wingdings",macd_MainColor);
     }
//-name label     
   ObjectCreate("macd"+IntegerToString(y,0),OBJ_LABEL,0,0,0);
   ObjectSet("macd"+IntegerToString(y,0),OBJPROP_CORNER,3);
   ObjectSet("macd"+IntegerToString(y,0),OBJPROP_XDISTANCE,35);
   ObjectSet("macd"+IntegerToString(y,0),OBJPROP_YDISTANCE,133);
   ObjectSetText("macd"+IntegerToString(y,0),"MACD MTF Panel",15,"Ariel",macd_MainColor);

   ObjectCreate("macdline1",OBJ_LABEL,0,0,0);
   ObjectSetText("macdline1","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("macdline1",OBJPROP_CORNER,3);
   ObjectSet("macdline1",OBJPROP_XDISTANCE,x);
   ObjectSet("macdline1",OBJPROP_YDISTANCE,130);

   ObjectCreate("macdline2",OBJ_LABEL,0,0,0);
   ObjectSetText("macdline2","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("macdline2",OBJPROP_CORNER,3);
   ObjectSet("macdline2",OBJPROP_XDISTANCE,x);
   ObjectSet("macdline2",OBJPROP_YDISTANCE,112);

   ObjectCreate("macdline3",OBJ_LABEL,0,0,0);
   ObjectSetText("macdline3","____________________________________",8,macd_font,macd_MainColor);
   ObjectSet("macdline3",OBJPROP_CORNER,3);
   ObjectSet("macdline3",OBJPROP_XDISTANCE,x);
   ObjectSet("macdline3",OBJPROP_YDISTANCE,22);
//------------------------------------------------------------------------------------------------- 

//------------------------------------------------------------------------------------------------- 
//-determines direction--red arrow shows macd is going up--green arrow shows macd is going down   
   for(x=0;x<9;x++)
     {
      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0)>
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0))
         ObjectSetText("macdarrow"+IntegerToString(x,0),CharToStr(228),12,"Wingdings",clrRed);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0)>
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0) && 
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,1)<
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,1))
         ObjectSetText("macdarrow"+IntegerToString(x,0),CharToStr(251),12,"Wingdings",clrRed);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0)<
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0))
         ObjectSetText("macdarrow"+IntegerToString(x,0),CharToStr(230),12,"Wingdings",clrGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,0)<
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0) && 
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_MAIN,1)>
         iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,1))
         ObjectSetText("macdarrow"+IntegerToString(x,0),CharToStr(251),12,"Wingdings",clrGreen);
     }
//-changes colors of the panel according to macd calculations     
   for(x=0;x<9;x++)
     {
      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus10)
         ObjectSetText("macdbox"+IntegerToString(x,0)+"0","_",30,macd_font,clrDarkGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus9)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"1","_",30,macd_font,clrGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus8)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"2","_",30,macd_font,clrForestGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus7)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"3","_",30,macd_font,clrLime);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus6)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"4","_",30,macd_font,clrLawnGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus5)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"5","_",30,macd_font,clrGreenYellow);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus4)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"6","_",30,macd_font,clrYellow);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus3)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"7","_",30,macd_font,clrGold);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus2)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"8","_",30,macd_font,clrOrange);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=levelminus1)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"9","_",30,macd_font,clrDarkOrange);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)<=0)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"10","_",30,macd_font,clrRed);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=0)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"10","_",30,macd_font,clrRed);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus1)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"11","_",30,macd_font,clrDarkOrange);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus2)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"12","_",30,macd_font,clrOrange);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus3)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"13","_",30,macd_font,clrGold);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus4)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"14","_",30,macd_font,clrYellow);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus5)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"15","_",30,macd_font,clrGreenYellow);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus6)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"16","_",30,macd_font,clrLawnGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus7)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"17","_",30,macd_font,clrLime);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus8)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"18","_",30,macd_font,clrForestGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus9)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"19","_",30,macd_font,clrGreen);

      if(iMACD(NULL,period[x],macdFastEMA,macdSlowEMA,macdSignal,PRICE_CLOSE,MODE_SIGNAL,0)>=levelplus10)
         ObjectSetText("macdbox"+DoubleToString(x,0)+"20","_",30,macd_font,clrDarkGreen);
     }
   WindowRedraw();
   return(0);
  }
//+------------------------------------------------------------------+
